'FFSubmenu=IPTC
'FFName=Schlagworteditor

'(c) Harald Maeckler, Dsseldorf 2016-2021
' ***********************************************************************
' Schlagworteditor.vbs (Skript fr FixFoto)
' Schlagworte in den IPTC-Daten editieren und speichern;
' auch Lschen und Einfgen in allen ausgewhlten JPG-Bildern ist mglich
' ***********************************************************************
'
' Version 2.05 vom 26.02.2021	- wegen Fehler in FF_HasIPCT doch nur jpg-Dateien
'								- Doppeleintrge bei 'Schlagworte im Bild' werden
'									beim Speichern bzw. Vor- und Zurckschalten entfernt
' Version 2.04 vom 23.02.2021	- Vermeidung eines Doppeleintrags beim Einfgen verbessert
'								- jetzt knnen auch in tif-Bilder mit IPTC-Datenblock
'									Schlagworte editiert werden
' Version 2.03 vom 12.02.2021	- Anzeige des Pfads begrenzt auf die letzten 80 Zeichen
' Version 2.02 vom 11.02.2021	- Anzeige des aktuellen Verzeichnisses bzw. Bilderliste
'								- Kontrolle ob zu bearbeitendes jpg-Bild IPTC-Block enthlt
' Version 2.01 vom 04.02.2021	- Verhinderung der Bearbeitung von allen Bildern
'									bei Anzeige von nicht bearbeitbarem Bild beseitigt
' Version 2.00 vom 03.02.2021	- Bearbeitung von markierten Bildern in Bilderliste
'								- Einstellung diverser Parameter
' Version 1.06 vom 28.01.2021	- Designpflege
' Version 1.05 vom 26.01.2021	- Designpflege
' Version 1.04 vom 26.01.2021	- alle nicht-jpg-Dateien werden bergangen
' Version 1.03 vom 10.01.2021	- Bug beim 'Einfgen' in alle Bilder behoben
' Version 1.02 vom 09.01.2021	- Update-URL aktualisiert
' Version 1.01 vom 26.06.2016	- beim Speichern Entfernung von Doppeleintrgen
'								- im Editorfeld wird automatisch eine neue Zeile angelegt
'								- keine Markierung des Editorfeldes nach Alt + N bzw. Alt + V
'									wenn alle Tasten innerhalb von 0,8 s losgelassen werden
' Version 1.00 vom 14.06.2016	- Betaversion
' ***********************************************************************

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "2.05"
const SkriptURL = "https://www.ffsf.de/resources/schlagworteditor.353/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'allgemeine Konstanten und Variable
const ForReading = 1, ForWriting = 2
Dim Abbruch,Antwort

'Spezifische Konstanten und Variable
Dim Bilder_Array,BNr,IPTC_Neu,n,m,SW,SW_Array
Dim IPTC_Date,Vorhanden,Vorhanden_Array,element
Dim KeinBild,KeineMarkierung,BwertArray,AW,Bildauswahl,ImagePath,CurrentList
const Bwerte = ",markierte Bilder der Computeransicht,,markierte Bilder der aktuellen Bilderliste"
const AzL = 80
Dim par_noMeld,par_endSpei,par_endLoe,par_endEin

'Objekte
Dim objFS,WshShell
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'Lschroutine
Dim SkriptKill,TempFile	 : SkriptKill = false
Dim SkriptName
const Skript = "Schlagworteditor"					'Skriptname
const RegSchluessel = "FF_Schlagworteditor"			'Registryschlssel

' ***********************************************************************
call main
Set WshShell = Nothing
Set objFS = Nothing
' ***********************************************************************
Sub main

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if err <> 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

KeinBild = FF_GetScriptPath & "\MeckiScript\Schlagworteditor\Kein_Bild.png"
KeineMarkierung = FF_GetScriptPath & "\MeckiScript\Schlagworteditor\Keine_Markierung.png"

'** Start Dialog Schlagworteditor **
FF_AddDialog "Schlagworteditor",268,210
FF_AddControl "Schlagworteditor","Bilderauswahl","GROUP",5,5,258,35
FF_AddControl "Schlagworteditor","nderungen speichern","GROUP",5,141,165,36
FF_AddControl "Schlagworteditor","im akt. Bild","GROUP",66,147,46,28
FF_AddControl "Schlagworteditor","in allen markierten Bildern","GROUP",184,142,80,36
FF_AddControl "Schlagworteditor","BildAnzeige","IMAGE",5,45,80,80
FF_AddControl "Schlagworteditor","Schlagworte","EDIT",90,57,80,68
FF_SetControlStyle "Schlagworteditor","Schlagworte",2097152
FF_AddControl "Schlagworteditor","SW_Eingabe","EDIT",184,57,80,68
FF_SetControlStyle "Schlagworteditor","SW_Eingabe",2097152
FF_AddControl "Schlagworteditor","<< &Vorheriges","BUTTON",9,159,48,11
FF_AddControl "Schlagworteditor","||","STATIC",5,129,165,10
FF_SetControlStyle "Schlagworteditor","||",1
FF_AddControl "Schlagworteditor","&Nchstes >>","BUTTON",118,159,48,11
FF_AddControl "Schlagworteditor","Fortschritt","PROGRESS",5,182,259,5
FF_AddControl "Schlagworteditor","Abbruch mit BACKSPACE mglich","STATIC",78,193,111,10
FF_SetControlStyle "Schlagworteditor","Abbruch mit BACKSPACE mglich",1
FF_AddControl "Schlagworteditor","?","BUTTON",8,192,11,11
FF_AddControl "Schlagworteditor","|","STATIC",23,193,20,10
FF_SetControlStyle "Schlagworteditor","|",1
FF_AddControl "Schlagworteditor","Update","BUTTON",48,192,28,11
FF_AddControl "Schlagworteditor","&Beenden","BUTTON",227,192,33,11
FF_AddControl "Schlagworteditor","&Speichern","BUTTON",72,159,33,11
FF_AddControl "Schlagworteditor","Strich","STATIC",176,45,4,133
FF_SetControlStyle "Schlagworteditor","Strich",17
FF_AddControl "Schlagworteditor","lschen / einfgen","STATIC",184,129,80,10
FF_SetControlStyle "Schlagworteditor","lschen / einfgen",1
FF_AddControl "Schlagworteditor","&Lschen","BUTTON",190,159,33,11
FF_AddControl "Schlagworteditor","&Einfgen","BUTTON",227,159,33,11
FF_AddControl "Schlagworteditor","&delete","BUTTON",0,17,1,1
FF_AddControl "Schlagworteditor","Neue Schlagworte","STATIC",184,45,80,10
FF_AddControl "Schlagworteditor","Auswahl","COMBO",39,14,140,10
FF_AddControl "Schlagworteditor","Schlagworte im Bild","STATIC",90,45,80,10
FF_AddControl "Schlagworteditor","&Aktualisieren","BUTTON",194,14,44,10
FF_AddControl "Schlagworteditor","&Parameter","BUTTON",190,192,33,11
FF_AddControl "Schlagworteditor","|||","STATIC",10,26,250,10
FF_SetControlStyle "Schlagworteditor","|||",1
'** End Dialog Schlagworteditor **

'Bilder
BwertArray = split(Bwerte,",")
FF_SetControl "Schlagworteditor","Auswahl",BwertArray(1)
FF_SetControl "Schlagworteditor","Auswahl",BwertArray(3)

AW = FF_GetProfile (RegSchluessel,"AW")
if AW = "" then AW = 1
FF_SetControl "Schlagworteditor","Auswahl",BwertArray(AW)
Bilder_Array = split(FF_GetSelection(AW),vbNewLine)

'Parameter
par_noMeld = FF_GetProfile (RegSchluessel,"par_noMeld")
if par_noMeld = "" then par_noMeld = 0
par_endSpei = FF_GetProfile (RegSchluessel,"par_endSpei")
if par_endSpei = "" then par_endSpei = 0
par_endLoe = FF_GetProfile (RegSchluessel,"par_endLoe")
if par_endLoe = "" then par_endLoe = 0
par_endEin = FF_GetProfile (RegSchluessel,"par_endEin")
if par_endEin = "" then par_endEin = 0

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Schlagworteditor","&Aktualisieren", "" &_
						 "Bilderauswahl nach genderter Markierung aktualisieren" & vbNewLine & vbNewLine &_
						 "(auch Aufruf mit Alt + A mglich)"
	FF_SetControlTooltip "Schlagworteditor","BildAnzeige", "" &_
						 "vor dem Speichern Wiederherstellung" & vbNewLine &_
						 "der Schlagwortliste mit Mausklick"
	FF_SetControlTooltip "Schlagworteditor","<< &Vorheriges", "" &_
						 "die angezeigten Schlagworte" & vbNewLine &_
						 "werden im aktuellen Bild eingetragen," & vbNewLine &_
						 "dann wird das vorige Bild aufgerufen" & vbNewLine & vbNewLine &_
						 "(auch Aufruf mit Alt + V mglich)"
	FF_SetControlTooltip "Schlagworteditor","&Nchstes >>", "" &_
						 "die angezeigten Schlagworte" & vbNewLine &_
						 "werden im aktuellen Bild eingetragen," & vbNewLine &_
						 "dann wird das nchste Bild aufgerufen" & vbNewLine & vbNewLine &_
						 "(auch Aufruf mit Alt + N mglich)"
	FF_SetControlTooltip "Schlagworteditor","?", "" &_
						 "Erluterungen zum Skript"
	FF_SetControlTooltip "Schlagworteditor","Update", "" &_
						 "Prfung ob eine neue Version vorliegt" & vbNewLine &_
						 "(eine Internetverbindung ist Voraussetzung)"
	FF_SetControlTooltip "Schlagworteditor","&Parameter", "" &_
						 "Einstellungsdialog ffnen" & vbNewLine & vbNewLine &_
						 "(auch Aufruf mit Alt + P mglich)"
	FF_SetControlTooltip "Schlagworteditor","&Beenden", "" &_
						 "Skript beenden" & vbNewLine & vbNewLine &_
						 "(auch Aufruf mit Alt + B mglich)"
	FF_SetControlTooltip "Schlagworteditor","&Speichern", "" &_	
						 "die angezeigten Schlagworte" & vbNewLine &_
						 "werden im aktuellen Bild eingetragen" & vbNewLine & vbNewLine &_
						 "(auch Aufruf mit Alt + S mglich)"
	FF_SetControlTooltip "Schlagworteditor","&Lschen", "" &_
						 "die eingegebenen Schlagworte" & vbNewLine &_
						 "werden in allen ausgewhlten JPG-Bildern gelscht" & vbNewLine & vbNewLine &_
						 "(auch Aufruf mit Alt + L mglich)"
	FF_SetControlTooltip "Schlagworteditor","&Einfgen", "" &_
						 "die eingegebenen Schlagworte" & vbNewLine &_
						 "werden in allen ausgewhlten JPG-Bildern eingetragen" & vbNewLine & vbNewLine &_
						 "(auch Aufruf mit Alt + E mglich)"
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 3500

FF_SetDialogTimer "Schlagworteditor", 100
FF_ActivateControl "Schlagworteditor","&delete"

do
	Abbruch = false
	
	Select Case FF_ShowDialog ("Schlagworteditor")
	Case "TIMER"
		FF_SetDialogTimer "Schlagworteditor", 0
		if AW = 1 then
			ImagePath = FF_GetImagePath
			if (len(ImagePath) + 5) > AzL then
				ImagePath = "... " & right(ImagePath,AzL)
			end if
			FF_SetControl "Schlagworteditor","|||",ImagePath
		end if

		if AW = 3 then
			CurrentList = FF_IListGetCurrentList
			if (len(CurrentList) + 5 + 13) > AzL then
				CurrentList = "... " & right(CurrentList,AzL - 13)
			end if
			FF_SetControl "Schlagworteditor","|||","Bilderliste: " & CurrentList
		end if

		FF_SetControl "Schlagworteditor" ,"|", "V " & Skriptversion
		BNr = 0 : call Anzeige
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "Auswahl","&Aktualisieren"
		if FF_GetControl("Schlagworteditor","Auswahl") = BwertArray(1) then
			AW = 1
		else
			AW = 3
		end if
		
		if AW = 1 then
			ImagePath = FF_GetImagePath
			if (len(ImagePath) + 5) > AzL then
				ImagePath = "... " & right(ImagePath,AzL)
			end if
			FF_SetControl "Schlagworteditor","|||",ImagePath
		end if
		
		if AW = 3 then
			CurrentList = FF_IListGetCurrentList
			if (len(CurrentList) + 5 + 13) > AzL then
				CurrentList = "... " & right(CurrentList,AzL - 13)
			end if
			FF_SetControl "Schlagworteditor","|||","Bilderliste: " & CurrentList
		end if
		
		Bilder_Array = split(FF_GetSelection(AW),vbNewLine)
		call Anzeige
	Case "BildAnzeige"
		if len(FF_GetSelection(AW)) > 0 then
			if FF_IdentifyImage(Bilder_Array(BNr)) = 2 then
				if len(FF_GetIPTC("Keywords")) > 0 then
					FF_SetControl "Schlagworteditor","Schlagworte",FF_GetIPTC("Keywords") & vbNewLine
				else
					FF_SetControl "Schlagworteditor","Schlagworte",FF_GetIPTC("Keywords")
				end if
				WshShell.SendKeys "{DOWN}"
			end if
		end if
	Case "&Nchstes >>"
		call Eintrag
		BNr = BNr +1
		call Anzeige
	Case "<< &Vorheriges"
		call Eintrag
		BNr = BNr -1
		call Anzeige
	Case "?"
		'FF_SetControl "Schlagworteditor","Fortschritt",55	'############## nur fr Screenshot
		on error resume next
		WshShell.Run chr(34) & FF_GetScriptPath & "\MeckiScript\Schlagworteditor\Schlagworteditor.pdf" & chr(34),1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht als PDF-Datei geffnet werden." & vbNewLine & _
				   "Die Datei ist gelscht oder es ist kein PDF-Reader installiert (?).",vbExclamation,"Hinweis"
			err.clear
		end if
		on error GoTo 0
		'WshShell.SendKeys "{DOWN}"
	Case "Update"
		if InternetConnection then
			SkriptEnde = false
			call Update
			if SkriptEnde then exit do
		end if
	Case "&Speichern"	'ins aktuelle Bild
		if len(FF_GetSelection(AW)) > 0 then call Eintrag
		if par_endSpei = 1 then exit do
	Case "&Lschen"
		if len(FF_GetSelection(AW)) > 0 then
			call Kontrolle
			if not Abbruch then
				call Loeschen
				FF_SetControl "Schlagworteditor","Fortschritt",0
			end if
		end if
		if par_endLoe = 1 then exit do
	Case "&Einfgen"
		if len(FF_GetSelection(AW)) > 0 then
			call Kontrolle
			if not Abbruch then
				call Einfuegen
				FF_SetControl "Schlagworteditor","Fortschritt",0
			end if
		end if
		if par_endEin = 1 then exit do
	Case "&Parameter"
		call Einstellungen
	Case "CANCEL","&Beenden"
		exit do
	End Select
loop

FF_WriteProfile RegSchluessel,"AW",AW
FF_CloseDialog ("Schlagworteditor")
if SkriptKill then
	call KillSkript
end if

End Sub
'------------------------------------------------------------------------
Sub Kontrolle
	
IPTC_Neu = trim(FF_GetControl("Schlagworteditor","SW_Eingabe"))
if len(IPTC_Neu) = 0 then
	msgbox "Es muss ein Schlagwort eingegeben werden!",vbInformation,"Hinweis"
	FF_ActivateControl "Schlagworteditor","SW_Eingabe"
	Abbruch = true : exit sub
end if

SW = FF_GetControl("Schlagworteditor","SW_Eingabe")
SW_Array = split(SW,vbNewLine)

End Sub
'------------------------------------------------------------------------
Sub Anzeige
Dim Bildfehler : Bildfehler = false

if len(FF_GetSelection(AW)) = 0 then
	FF_SetControl "Schlagworteditor","BildAnzeige",KeineMarkierung
	FF_SetControl "Schlagworteditor","||",""
	FF_SetControl "Schlagworteditor","Schlagworte",""
	FF_EnableControl "Schlagworteditor","Schlagworte",false
	FF_EnableControl "Schlagworteditor","<< &Vorheriges",false
	FF_EnableControl "Schlagworteditor","&Speichern",false
	FF_EnableControl "Schlagworteditor","&Nchstes >>",false
	FF_SetControl "Schlagworteditor","SW_Eingabe",""
	FF_EnableControl "Schlagworteditor","SW_Eingabe",false
	FF_EnableControl "Schlagworteditor","&Lschen",false
	FF_EnableControl "Schlagworteditor","&Einfgen",false
	exit sub
else
	FF_EnableControl "Schlagworteditor","Schlagworte",true
	FF_EnableControl "Schlagworteditor","<< &Vorheriges",true
	FF_EnableControl "Schlagworteditor","&Speichern",true
	FF_EnableControl "Schlagworteditor","&Nchstes >>",true
	FF_EnableControl "Schlagworteditor","SW_Eingabe",true
	FF_EnableControl "Schlagworteditor","&Lschen",true
	FF_EnableControl "Schlagworteditor","&Einfgen",true
end if

FF_SetControl "Schlagworteditor","||",objFS.GetFileName(Bilder_Array(BNr))
FF_SetControl "Schlagworteditor","BildAnzeige",Bilder_Array(BNr)

on error resume next
	FF_LoadImage Bilder_Array(BNr)
if err <> 0 then
	Bildfehler = true
	FF_SetControl "Schlagworteditor","BildAnzeige",KeinBild
end if
on error goto 0

if BNr = 0 then
	FF_EnableControl "Schlagworteditor","<< &Vorheriges",false
else
	FF_EnableControl "Schlagworteditor","<< &Vorheriges",true
end if

if BNr = ubound(Bilder_Array) then
	FF_EnableControl "Schlagworteditor","&Nchstes >>",false
else
	FF_EnableControl "Schlagworteditor","&Nchstes >>",true
end if

if Bildfehler then
	FF_SetControl "Schlagworteditor","Schlagworte",""
	FF_EnableControl "Schlagworteditor","Schlagworte",false
	FF_EnableControl "Schlagworteditor","&Speichern",false
	exit sub
else
	FF_EnableControl "Schlagworteditor","Schlagworte",true
	FF_EnableControl "Schlagworteditor","&Speichern",true
end if

if FF_IdentifyImage(Bilder_Array(BNr)) = 2 then
	FF_EnableControl "Schlagworteditor","Schlagworte",true
	FF_ActivateControl "Schlagworteditor","SW_Eingabe"
	if len(FF_GetIPTC("Keywords")) > 0 then
		FF_SetControl "Schlagworteditor","Schlagworte",FF_GetIPTC("Keywords") & vbNewLine
	else
		FF_SetControl "Schlagworteditor","Schlagworte",FF_GetIPTC("Keywords")
	end if
	FF_Sleep 800
	WshShell.SendKeys "{DOWN}"
else
	FF_SetControl "Schlagworteditor","Schlagworte",vbNewLine & vbNewLine & vbNewLine &_
		space(5) & "Kein IPTC-" & vbNewLine & space(5) & "Datenblock" & vbNewLine & space(5) & "vorhanden"
	FF_EnableControl "Schlagworteditor","Schlagworte",false
end if

End Sub
'------------------------------------------------------------------------
Sub Eintrag

'## Doppeleintrge entfernen
Dim KW,KW_Array,KW_Neu,OK

KW = FF_GetControl("Schlagworteditor","Schlagworte")

if len(KW) > 0 then
	KW_Array = split(KW,vbNewLine)
	if ubound(KW_Array) > 0 then
		for m = 0 to ubound(KW_Array) -1
			OK = true
			for n = m +1 to ubound(KW_Array)
				if trim(ucase(KW_Array(m))) = trim(ucase(KW_Array(n))) then
					OK = false : exit for
				end if 
			next
			if OK then
				if len(KW_Neu) = 0 then
					KW_Neu = KW_Array(m)
				else
					KW_Neu = KW_Neu & vbNewLine & KW_Array(m)
				end if
			end if	
		next
	end if
	KW_Neu = KW_Neu & vbNewLine & KW_Array(ubound(KW_Array))
else
	KW_Neu = ""
end if

if instr(KW_Neu,vbNewLine) = 1 then KW_Neu = mid(KW_Neu,3)
FF_SetControl"Schlagworteditor","Schlagworte",KW_Neu

'## Schlagworte eintragen und sichern
FF_SetIPTC "Keywords",KW_Neu
FF_SaveIPTC Bilder_Array(BNr)

End Sub
'------------------------------------------------------------------------
Sub Loeschen
Dim msg1,msg2

m = 0

FF_SetControl "Schlagworteditor","Fortschritt",0

for n = 0 to ubound(Bilder_Array)

	if FF_IdentifyImage(Bilder_Array(n)) = 2 then
		FF_LoadImage Bilder_Array(n)
		IPTC_Date = ""
		Vorhanden = FF_GetIPTC("Keywords")
		Vorhanden_Array = split(Vorhanden,vbNewLine)
		for each element in Vorhanden_Array
			if instr(ucase(SW),ucase(element)) = 0 then
				if len(IPTC_Date) = 0 then
					IPTC_Date = element
				else
					IPTC_Date = IPTC_Date & vbNewLine & element
				end if
			end if
		next
		FF_SetIPTC "Keywords", IPTC_Date
		FF_SaveIPTC Bilder_Array(n)
	else
		m = m +1
	end if
	
	FF_SetControl "Schlagworteditor","Fortschritt",(n +1)/(ubound(Bilder_Array) +1)*100

	if FF_CheckKey() = 8 then 	'8 = Backspace
		Antwort = msgbox("Von " & ubound(Bilder_Array) +1 & " Bildern wurden bisher " & n +1 & " Bilder bearbeitet." & vbNewLine & vbNewLine & _
						"Soll die Bearbeitung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
		if Antwort = vbYes then
			FF_SetControl "Schlagworteditor","Fortschritt",0
			exit sub
		end if
	end if
	
next

if FF_IdentifyImage(Bilder_Array(BNr)) = 2 then
	FF_LoadImage Bilder_Array(BNr)
	FF_SetControl "Schlagworteditor","Schlagworte",FF_GetIPTC("Keywords")
	FF_ActivateControl "Schlagworteditor","SW_Eingabe"
end if
FF_SetControl "Schlagworteditor","SW_Eingabe",""

if par_noMeld = 0 then	
	if n = 1 then msg1 = "Es wurde 1 Bild bearbeitet!"
	if n > 1 then msg1 = "Es wurden " & n & " Bilder bearbeitet!"
	if m = 1 then msg2 = "Ein Bild davon hat keinen IPTC-Datenblock."
	if m > 1 then msg2 = m & " Bilder davon haben keinen IPTC-Datenblock."
	if m > 0 then msg1 = msg1 & vbNewLine & msg2	
	msgbox msg1,vbInformation,"Meldung"
end if

End Sub
'------------------------------------------------------------------------
Sub Einfuegen
Dim x,msg1,msg2,OK
x = 0

for n = 0 to ubound(Bilder_Array)
	if FF_IdentifyImage(Bilder_Array(n)) = 2 then
		FF_LoadImage Bilder_Array(n)
		Vorhanden = FF_GetIPTC("Keywords")
		Vorhanden_Array = split(Vorhanden,vbNewLine)
		if len(Vorhanden) = 0 then
			Vorhanden = IPTC_Neu
		else
			for m = 0 to ubound(SW_Array)
				if len(SW_Array(m)) = 0 then exit for
				OK = true
				for each element in Vorhanden_Array
					if ucase(element) = ucase(SW_Array(m)) then	OK = false
				next
				if OK then Vorhanden = Vorhanden & vbNewLine & SW_Array(m)
			next
		end if
		FF_SetIPTC "Keywords",Vorhanden
		FF_SaveIPTC Bilder_Array(n)
	else
		x = x +1
	end if
	
	FF_SetControl "Schlagworteditor","Fortschritt",(n +1)/(ubound(Bilder_Array) +1)*100

	if FF_CheckKey() = 8 then 	'8 = Backspace
		Antwort = msgbox("Von " & ubound(Bilder_Array) +1 & " Bildern wurden bisher " & n +1 & " Bilder bearbeitet." & vbNewLine & vbNewLine & _
						"Soll die Bearbeitung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
		if Antwort = vbYes then
			FF_SetControl "Schlagworteditor","Fortschritt",0
			exit sub
		end if
	end if
	
next

if FF_IdentifyImage(Bilder_Array(BNr)) = 2 then 
	FF_LoadImage Bilder_Array(BNr)
	FF_SetControl "Schlagworteditor","Schlagworte",FF_GetIPTC("Keywords")
	FF_ActivateControl "Schlagworteditor","SW_Eingabe"
end if
FF_SetControl "Schlagworteditor","SW_Eingabe",""

if par_noMeld = 0 then	
	if n = 1 then msg1 = "Es wurde 1 Bild bearbeitet!"
	if n > 1 then msg1 = "Es wurden " & n & " Bilder bearbeitet!"
	if x = 1 then msg2 = "Ein Bild davon hat keinen IPTC-Datenblock."
	if x > 1 then msg2 = x & " Bilder davon haben keinen IPTC-Datenblock."
	if x > 0 then msg1 = msg1 & vbNewLine & msg2	
	msgbox msg1,vbInformation,"Meldung"
end if

End Sub
'------------------------------------------------------------------------
Sub Einstellungen
'Parameter verarbeiten

'** Start Dialog Einstellungen **
FF_AddDialog "Einstellungen",170,109
FF_AddControl "Einstellungen","Fertigmeldungen bei","STATIC",15,10,110,10
FF_AddControl "Einstellungen","'Lschen' und 'Einfgen' unterdrcken","STATIC",16,20,110,10
FF_AddControl "Einstellungen","par_noMeld","BOOL",141,16,8,8
FF_AddControl "Einstellungen","Skript beenden nach Ausfhrung von","STATIC",15,40,110,10
FF_AddControl "Einstellungen","Speichern","STATIC",15,55,110,10
FF_AddControl "Einstellungen","Lschen","STATIC",15,65,110,10
FF_AddControl "Einstellungen","Einfgen","STATIC",15,75,110,10
FF_AddControl "Einstellungen","par_endSpei","BOOL",141,56,8,8
FF_AddControl "Einstellungen","par_endLoe","BOOL",141,66,8,8
FF_AddControl "Einstellungen","par_endEin","BOOL",141,76,8,8
FF_AddControl "Einstellungen","bernehmen","BUTTON",62,91,45,11
'** End Dialog Einstellungen **

FF_SetControl "Einstellungen","par_noMeld",par_noMeld
FF_SetControl "Einstellungen","par_endSpei",par_endSpei
FF_SetControl "Einstellungen","par_endLoe",par_endLoe
FF_SetControl "Einstellungen","par_endEin",par_endEin

do
	Select Case FF_ShowDialog ("Einstellungen")

	Case "bernehmen"
		par_noMeld = FF_GetControl("Einstellungen","par_noMeld")
		par_endSpei = FF_GetControl("Einstellungen","par_endSpei")
		par_endLoe = FF_GetControl("Einstellungen","par_endLoe")
		par_endEin = FF_GetControl("Einstellungen","par_endEin")
		exit do
	Case "CANCEL"
		exit do
	End Select
loop

FF_WriteProfile RegSchluessel,"par_noMeld",par_noMeld
FF_WriteProfile RegSchluessel,"par_endSpei",par_endSpei
FF_WriteProfile RegSchluessel,"par_endLoe",par_endLoe
FF_WriteProfile RegSchluessel,"par_endEin",par_endEin

FF_CloseDialog ("Einstellungen")

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Internetverbindung ?
'************************************************************************
'------------------------------------------------------------------------
Function InternetConnection
 
Dim obj
Set obj = GetObject("winmgmts:Win32_PingStatus.address='" & "google.de" & "'")

if IsNull(obj.StatusCode) or obj.StatusCode <> 0 Then
   msgbox "Keine Internetverbindung!",vbInformation,"Hinweis"
   InternetConnection = false
else
   InternetConnection = true
end if
 
End Function
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
'------------------------------------------------------------------------
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
		pos2 = instr(pos1 ,Inhalt,".")											'"." ersetzt "<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2 +3 -pos1))					'+3 hinzugefgt
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Lschroutine
'************************************************************************
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Ordner lschen
TempFile = FF_GetScriptPath & "\MeckiScript\Schlagworteditor"
if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### ggf. Registry-Daten lschen
'TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
'WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Standard-Funktionen
'************************************************************************
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
